# Clusternet Roadmap

This document outlines a high-level roadmap for
Clusternet. [GitHub milestones](https://github.com/clusternet/clusternet/milestones) are used to track the progress of
this project. This roadmap is updated frequently to reflect the community's overall thinking on the future of the
project.

## 2021

- Cluster registrations across different heterogeneous environments, .e.g., public cloud, private cloud, hybrid, and
  edge cloud
- Coordination of various application types, `Deployments`, `CRDs`, `HelmCharts`, etc. to multiple clusters
- Full RBAC supports on child clusters
- Diversified application override policies
- Support for more Kubernetes versions
- Pluggable cross-cluster scheduling policies
- User and developer experience improvement
- Clusternet CIs Enhancements

## 2022

- E2E tests
- Benchmarks on cluster management and application coordination
- Service discovery across multiple clusters
- Service mesh support
- Cross-cluster HPA
- Monitoring and logging for multiple clusters
- Data planes integration across multiple clusters
