/*
Copyright The Clusternet Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1alpha1 "github.com/clusternet/clusternet/pkg/apis/apps/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeDescriptions implements DescriptionInterface
type FakeDescriptions struct {
	Fake *FakeAppsV1alpha1
	ns   string
}

var descriptionsResource = schema.GroupVersionResource{Group: "apps.clusternet.io", Version: "v1alpha1", Resource: "descriptions"}

var descriptionsKind = schema.GroupVersionKind{Group: "apps.clusternet.io", Version: "v1alpha1", Kind: "Description"}

// Get takes name of the description, and returns the corresponding description object, and an error if there is any.
func (c *FakeDescriptions) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.Description, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(descriptionsResource, c.ns, name), &v1alpha1.Description{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Description), err
}

// List takes label and field selectors, and returns the list of Descriptions that match those selectors.
func (c *FakeDescriptions) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.DescriptionList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(descriptionsResource, descriptionsKind, c.ns, opts), &v1alpha1.DescriptionList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.DescriptionList{ListMeta: obj.(*v1alpha1.DescriptionList).ListMeta}
	for _, item := range obj.(*v1alpha1.DescriptionList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested descriptions.
func (c *FakeDescriptions) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(descriptionsResource, c.ns, opts))

}

// Create takes the representation of a description and creates it.  Returns the server's representation of the description, and an error, if there is any.
func (c *FakeDescriptions) Create(ctx context.Context, description *v1alpha1.Description, opts v1.CreateOptions) (result *v1alpha1.Description, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(descriptionsResource, c.ns, description), &v1alpha1.Description{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Description), err
}

// Update takes the representation of a description and updates it. Returns the server's representation of the description, and an error, if there is any.
func (c *FakeDescriptions) Update(ctx context.Context, description *v1alpha1.Description, opts v1.UpdateOptions) (result *v1alpha1.Description, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(descriptionsResource, c.ns, description), &v1alpha1.Description{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Description), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeDescriptions) UpdateStatus(ctx context.Context, description *v1alpha1.Description, opts v1.UpdateOptions) (*v1alpha1.Description, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(descriptionsResource, "status", c.ns, description), &v1alpha1.Description{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Description), err
}

// Delete takes name of the description and deletes it. Returns an error if one occurs.
func (c *FakeDescriptions) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(descriptionsResource, c.ns, name, opts), &v1alpha1.Description{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeDescriptions) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(descriptionsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1alpha1.DescriptionList{})
	return err
}

// Patch applies the patch and returns the patched description.
func (c *FakeDescriptions) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.Description, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(descriptionsResource, c.ns, name, pt, data, subresources...), &v1alpha1.Description{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.Description), err
}
